#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#include <conio.h>
#include "winscard.h"
#include "SC_PIN.H"
#include "spe_standard.h"

// select a card, which you want to use resp. add your own
#define TCOS			1
//#define STARACCOUNT_PIN2	1

VOID main(VOID) 
{ 
		
	BYTE				i,FirstCharTimeOut, SubTimeOut, PIN_Format, Key;

	WORD				PIN_MinMax;
	
	DWORD				ret, ActiveProtocol, VerifyPINStart, VerifyPINFinish, GetKeyPressed, dwBytesRead;

	BYTE				bBuffer[256];

	SCARDCONTEXT		ContextHandle;
	SCARDHANDLE			CardHandle;

	_USB_CCID_PIN_VERIFY_STRUCTURE strVrf;

	size_t				speSize;
	size_t				apduSize;
	size_t				sendBufferSize;

	UCHAR				*sendBuffer;


	char				*SPRx3xReaderName[] =	{	
													"SCM Microsystems Inc. SPRx32 USB Smart Card Reader 0",	
//													"SCM Microsystems Inc. SPRx32 Serial Smart Card Reader 0",	
													NULL
												};
#if defined (STARACCOUNT_PIN2) 
	SCARD_IO_REQUEST	IO_Request;

	DWORD				ResLen;
	unsigned char		ResponseBuffer[64];
#endif


#if defined (TCOS)
#if defined (STARACCOUNT_PIN2)
	Error "wrong compilation options"
#endif
#endif
#if !defined (TCOS)
#if !defined (STARACCOUNT_PIN2)
	Error "wrong compilation options"
#endif
#endif

/********************************************************************************************************/
/* specify your specific PIN paramters:																	*/
/* ====================================																	*/
/*																										*/
/*	please check the specification of your smart card and for further details							*/
/*																										*/
/********************************************************************************************************/
#if defined (TCOS)
	// Telesec NETKEY card, ASCII PIN:
	//================================
	UCHAR			APDU_VERIFY_PIN[11] = { 0x00, 0x20, 0x00, 0x00, 0x06, 
											0xFF , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF }; 
	PIN_Format = CCID_PIN_ASCII;
	PIN_MinMax = 0x0106;
	printf ("\n PIN test with TCOS card (ASCII format)\n");
#else
	#if defined (STARACCOUNT_PIN2)
		// STARACCOUNT card, PIN2 format PIN:
		//===================================
		UCHAR			APDU_SELECT_FILE[14] = { 0x00, 0xA4, 0x04, 0x0C, 0x09, 
												0xD2 , 0x76 , 0x00 , 0x00 , 0x74 , 0x48, 0x42, 0x01, 0x10 }; 

//		002000900826123456FFFFFFFF
		UCHAR			APDU_VERIFY_PIN[13] = { 0x00, 0x20, 0x00, 0x90, 0x08, 
												0x20, 0xFF , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF}; 

		PIN_Format = CCID_FORMAT_PIN_BCD;
		PIN_MinMax = 0x040C;
		printf ("\n PIN test with StarAccount card (PIN2 format)\n");
	#endif
#endif
	FirstCharTimeOut = 15;
	SubTimeOut = 5;							
	
/********************************************************************************************************/

	// get the PC/SC handle
	ret = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &ContextHandle);
	
	if (SCARD_S_SUCCESS == ret) 
	{       
		ret = SCardConnect(	ContextHandle, 
							SPRx3xReaderName[0],
							SCARD_SHARE_SHARED, 
							SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1, 
							&CardHandle, 
							&ActiveProtocol);
		if (SCARD_S_SUCCESS == ret) 
		{


/********************************************************************************************************/
/* Get Features with IOCTL code																			*/
/********************************************************************************************************/
			ret = SCardControl(	CardHandle,
								CM_IOCTL_GET_FEATURE_REQUEST,
								NULL,
								0,
								bBuffer,
								sizeof(bBuffer),
								&dwBytesRead);

			if (SCARD_S_SUCCESS == ret) 
			{
				printf ("\n SCardControl CM_IOCTL_GET_FEATURE_REQUEST passed: 0x%.8lx",ret);
			}
			else
			{
				printf ("\n SCardControl CM_IOCTL_GET_FEATURE_REQUEST failed: 0x%.8lx",ret);
			}

			

			GetKeyPressed = 0;
			VerifyPINStart = 0;
			VerifyPINFinish = 0;
			for (i = 0; i < dwBytesRead; i+=6 )
			{
				if (bBuffer[i] == FEATURE_VERIFY_PIN_START)
				{
					VerifyPINStart = (DWORD) (bBuffer[i+2]<<24) +
					                    (DWORD) (bBuffer[i+3]<<16) +
					                    (DWORD) (bBuffer[i+4]<< 8) +
					                    (DWORD) (bBuffer[i+5]    );
				}
				else
				{
					if (bBuffer[i] == FEATURE_VERIFY_PIN_FINISH)
					{
						VerifyPINFinish = (DWORD) (bBuffer[i+2]<<24) +
											(DWORD) (bBuffer[i+3]<<16) +
											(DWORD) (bBuffer[i+4]<< 8) +
											(DWORD) (bBuffer[i+5]    );
					}
					else
					{
						if (bBuffer[i] == FEATURE_GET_KEY_PRESSED)
						{
							GetKeyPressed = (DWORD) (bBuffer[i+2]<<24) +
												(DWORD) (bBuffer[i+3]<<16) +
												(DWORD) (bBuffer[i+4]<< 8) +
												(DWORD) (bBuffer[i+5]    );
						}

					}
				}
			}
			if ((0 == VerifyPINStart) || (0 == VerifyPINFinish))
			{
				printf ("\nError: IOCTL code not found\n");

			}
			else
			{

/********************************************************************************************************/
/* select file 																							*/
/********************************************************************************************************/
#if defined (STARACCOUNT_PIN2)
				IO_Request.dwProtocol = ActiveProtocol;;
				IO_Request.cbPciLength = (DWORD) sizeof(SCARD_IO_REQUEST);

				ResLen = sizeof (ResponseBuffer);
				ret = SCardTransmit(CardHandle, &IO_Request, APDU_SELECT_FILE, sizeof (APDU_SELECT_FILE), 
									0, ResponseBuffer, &ResLen);
				// todo: check smartcard response....
#endif
			
/********************************************************************************************************/
/* Verify PIN																							*/
/********************************************************************************************************/

				strVrf.bTimeOut = FirstCharTimeOut;

				strVrf.bTimeOut2 = SubTimeOut;

				strVrf.bmFormatString = PIN_Format;

				strVrf.bmPINBlockString          = 0x00;	;

#if defined (STARACCOUNT_PIN2)
				strVrf.bmPINBlockString          = 0x40;  // used to identify PIN2 format
#endif
				strVrf.bmPINLengthFormat         = 0x00;

				strVrf.wPINMaxExtraDigit         = PIN_MinMax;

				strVrf.bEntryValidationCondition = VALIDATION_KEY_PRESSED;

				strVrf.bNumberMessage            = 0x00;		// no message

				strVrf.wLangId                   = 0x0000;		// not supported

				strVrf.bMsgIndex                 = 0x00;
				strVrf.bTeoPrologue[0] = 0x00;
				strVrf.bTeoPrologue[1] = 0x00;
				strVrf.bTeoPrologue[2] = 0x00;

				strVrf.ulDataLength =   sizeof (APDU_VERIFY_PIN);

				speSize  = sizeof( _USB_CCID_PIN_VERIFY_STRUCTURE ) - 1;
				apduSize = strVrf.ulDataLength;
				sendBufferSize = speSize + apduSize;
				
				sendBuffer = (UCHAR *)malloc(sendBufferSize);
				if (NULL == sendBuffer) 
				{
					printf("\nError: no memory available\n");
				}
				else
				{
					memcpy( sendBuffer, (UCHAR *)&strVrf, speSize  );
					memcpy( sendBuffer + speSize, APDU_VERIFY_PIN, apduSize );
			
					printf ("\n Verify PIN \n");

					ret = SCardControl (CardHandle,							
										 VerifyPINStart,
										 sendBuffer,
										 sendBufferSize,
										 bBuffer,
										 sizeof(bBuffer),
										 &dwBytesRead);

					free(sendBuffer);

					/*********************************************************************************************/
#if 0
					if (0 != GetKeyPressed)
					{
							printf ("\n #1: press any key at SPR532 and"); 
							printf ("\n #2: continue pressing any key at your PC keyboard to continue the application");
							printf ("\n #3: finalize your PIN entry at SPR532");
							
							for (i=0; i < 10; i++)
							{
								getch();

								ret = SCardControl (CardHandle,							
													 GetKeyPressed,
													 NULL,
													 0,
													 &Key,
													 1,
													 &dwBytesRead);

								printf("\n GetKey RetCode=0x%.8lx: %x ",ret,Key);
							}
							printf ("\n GetKey finished, press any key to continue");
							getch();

					}
#endif
					/*********************************************************************************************/
					
					if (SCARD_S_SUCCESS == ret)
					{
						ret = SCardControl (CardHandle,
											 VerifyPINFinish,
											 NULL,
											 0,
											 bBuffer,
											 sizeof(bBuffer),
											 &dwBytesRead);


						if (SCARD_S_SUCCESS == ret)
						{
							printf("\nCard returned: 0x%.2x%.2x \n", bBuffer[0], bBuffer[1]);
						}
						else
						{	
							printf("\nError %.8lx\n",ret);
						}
					}
					else
					{	
						printf("\nError %.8lx\n",ret);
					}
				}

			}

/********************************************************************************************************/
		}
		else
		{
			printf ("\nError: SmartCard not connected \n");
		}
		// release the PC/SC handle
		SCardReleaseContext(ContextHandle);
	}
	else
	{
		printf ("\nError: PC/SC context not established \n");		
	}

	printf("\npress any key to close the test tool\n");
	getch();
} 